//
// Copyright 2004 Alan Post
//
// This file is part of voudp.
//
// voudp is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// voudp is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// voudp; if not, write to the Free Software Foundation, Inc., 59 Temple Place,
// Suite 330, Boston, MA  02111-1307  USA
//

#ifndef __CONSTANTS_H__
#define __CONSTANTS_H__

#include <sys/types.h>

typedef u_int32_t client_id_t;
typedef u_int32_t frame_id_t;
typedef u_int8_t frame_len_t;
static const ssize_t frame_header_size =   sizeof( frame_id_t )
                                         + sizeof( frame_len_t );
static const ssize_t samples_per_sec = 8000;

//
// This is 160 for all the 8kHz speex modes
//
static const u_int samples_per_frame = 160;

static const u_int hw_channels = 2;
typedef struct { int16_t s[hw_channels]; } hw_sample_t;

#endif // __CONSTANTS_H__
