//
// Copyright 2004 Alan Post
//
// This file is part of voudp.
//
// voudp is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// voudp is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// voudp; if not, write to the Free Software Foundation, Inc., 59 Temple Place,
// Suite 330, Boston, MA  02111-1307  USA
//

#ifndef __RECORDER_H__
#define __RECORDER_H__

#include "constants.h"
#include <sys/types.h>

class Sender;

class Recorder
{
public:
    Recorder(       u_int8_t    *dma_buf,
              const int         &afd,
              const size_t      &blocksize,     // in bytes
              const size_t      &buffer_size ); // in bytes

    void record_if_needed( Sender &receiver );
private:
    u_int8_t *dma_buf;
    int afd;
    size_t blocksize;
    size_t blocks_in_buffer;
    size_t samples_per_block;

    ssize_t last_read_block;
    u_int frame_write_offset;
    float frame[ samples_per_frame ];
};

#endif // __RECORDER_H__
