//
// Copyright 2004 Alan Post
//
// This file is part of voudp.
//
// voudp is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// voudp is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// voudp; if not, write to the Free Software Foundation, Inc., 59 Temple Place,
// Suite 330, Boston, MA  02111-1307  USA
//

#ifndef __VOUDPCONFIG_MSG_H__
#define __VOUDPCONFIG_MSG_H__

#include <sys/param.h>
#include <string>

extern const char *sock_path;

class recipient_info_t;

class voudpconfig_msg
{
public:
    typedef enum {
        SHOW_ALL,
        GET_INFO,
        SET_INFO,
        DELETE,
        START,
        STOP,
        PRINT_DIAGNOSTICS
    } req_code_t;

    typedef enum {
        FOUND,
        NOT_FOUND,
        OK
    } resp_code_t;
};

bool send_req_code( int fd, const voudpconfig_msg::req_code_t &code );
bool decode_req_code( int fd, voudpconfig_msg::req_code_t &code );

bool send_resp_code( int fd, const voudpconfig_msg::resp_code_t &code );
bool decode_resp_code( int fd, voudpconfig_msg::resp_code_t &code );

bool send_name( int fd, const std::string &name );
bool decode_name( int fd, std::string &name );

bool send_info( int fd, const recipient_info_t &info );
bool decode_info( int fd, recipient_info_t &info );

bool send_bool( int fd, const bool &b );
bool decode_bool( int fd, bool &b );

#endif // __VOUDPCONFIG_MSG_H__
